<template>
<#if ctrl.render??>
    ${ctrl.render.code}
<#else>
    <div class="app-dr-tab<#if ctrl.getPSSysCss?? && ctrl.getPSSysCss()??><#assign singleCss = ctrl.getPSSysCss()> ${singleCss.getCssName()}</#if>">
        <div
            v-for="(item, index) in items"
            :class="{
                'app-dr-tab-item': true,
                'dr-tab-item': true,
                'is-disabled': item.disabled,
                'is-active': selection.id === item.id
            }"
            @click="handleDrTabChange(item)">
            <span class="text">{{ item.text }}</span>
        </div>
    </div>   
</#if> 
</template>
// 基于 @CONTROL/数据关系分页部件/CONTROL-BASE.vue.ftl 生成
<#ibizinclude>
../@MACRO/CONTROL/CONTROL_HEADER-BASE.vue.ftl
</#ibizinclude>

<#ibizinclude>
../@MACRO/FUNC/MACRO.ftl
</#ibizinclude>
    /**
     * 是否默认加载数据
     *
     * @type {boolean}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    @Prop({ default: false }) public selectDefault?: boolean;

    /**
     *  应用实体参数名称
     *
     * @type string
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    @Prop() public parentName!: string;

    /**
     * 表单数据
     *
     * @type {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public formData: any;
    
    /**
     * 获取多项数据
     *
     * @returns {any[]}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public getDatas(): any[] {
        return this.items;
    }

    /**
     * 获取单项树
     *
     * @returns {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public getData(): any {
        return this.selection;
    }

    /**
     * 数据选中项
     *
     * @type {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public selection: any = {};

    /**
     * 父数据
     *
     * @public
     * @type {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public parentData: any = {};

    /**
     * 关系栏数据项
     *
     * @type {any[]}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public items: any[] = [
<#if ctrl.getPSDEDRTabPages?? && ctrl.getPSDEDRTabPages()??>
    <#list ctrl.getPSDEDRTabPages() as item>
        {
            id: '${item.getId()?lower_case}',
            name: '${item.getId()?lower_case}',
            text: '${item.getCaption()}',
            disabled: true,
            navView: '<#if item.getPSAppView?? && item.getPSAppView()??>${srffilepath2(item.getPSAppView().codeName)}</#if>',
        <#if item.getPSSysImage()??>
            iconcls: '${item.getPSSysImage().getCssClass()}',
            icon: '${item.getPSSysImage().getImagePath()}',
        </#if>
            localContext: <#if item.getPSNavigateContexts?? && item.getPSNavigateContexts()??><@getNavigateContext item /><#else>null</#if>,
            localViewParam: <#if item.getPSNavigateParams?? && item.getPSNavigateParams()??><@getNavigateParams item /><#else>null</#if>
        },
    </#list>
</#if>
    ];

    /**
     * 生命周期
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public created(): void {
        this.afterCreated();
    }

    /**
     * 执行created后的逻辑
     *
     *  @memberof ${srfclassname('${ctrl.codeName}')}Base
     */    
    public afterCreated(){
        if (this.viewState) {
            this.viewStateEvent = this.viewState.subscribe(({ tag, action, data }) => {
                if (!Object.is(tag, this.name)) {
                    return;
                }
                if (Object.is('state', action)) {
                    this.handleFormDataChange(data);
                }
                if (Object.is('change', action)) {
                    this.selection = data;
                }
            });
        }
    }

    /**
     * vue 生命周期
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public destroyed() {
        this.afterDestroy();
    }

    /**
     * 执行destroyed后的逻辑
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public afterDestroy() {
        if (this.viewStateEvent) {
            this.viewStateEvent.unsubscribe();
        }
        <#if destroyed_block??>
        ${destroyed_block}
        </#if>
    }

    /**
     * 处理表单数据变化
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public handleFormDataChange(data: any) {
        this.formData = data;
        if (data && Object.is(data.srfuf, '1')) {
            this.items.forEach((item: any) => {
                item.disabled = false;
            })
        } else {
            this.items.forEach((item: any) => {
                item.disabled = true;
            })
        }
        if (this.selectDefault && this.items.length > 0) {
            this.handleDrTabChange(this.items[0]);
        }
    }

    /**
     * 处理分页项变化
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public handleDrTabChange(item: any) {
        if (this.selection && this.selection.id === item.id) {
            return;
        }
        this.selection = item;
        const tempContext = Util.deepCopy(this.context);
        const tempViewParams = Util.deepCopy(this.viewparams);
        if (item.localContext && Object.keys(item.localContext).length > 0) {
            const _context: any = this.$util.computedNavData(this.formData, tempContext, tempViewParams, item.localContext);
            Object.assign(tempContext, _context);
        }
        if (this.formData.srfparentkey) {
           Object.assign(tempContext, { srfparentkey: this.formData.srfparentkey });
           Object.assign(tempViewParams, { srfparentkey: this.formData.srfparentkey });
        }
        if (item.localViewParam && Object.keys(item.localViewParam).length > 0) {
            const _params: any = this.$util.computedNavData(this.formData, tempContext, tempViewParams, item.localViewParam);
            Object.assign(tempViewParams, _params);
        }
        if (this.formData.srfparentdename) {
            Object.assign(tempContext, { srfparentdename: this.formData.srfparentdename });
            Object.assign(tempViewParams, { srfparentdename: this.formData.srfparentdename });
        }
        const drItem = {
            id: item.id,
            navView: item.navView,
            srfnavdata: {
                context: tempContext,
                viewparams: tempViewParams
            }
        }
        this.$emit('selectionchange', drItem);
    }

<#ibizinclude>
../@MACRO/CONTROL/CONTROL_BOTTOM-BASE.vue.ftl
</#ibizinclude>

<#ibizinclude>
../@MACRO/CONTROL/CONTROL-BASE.style.ftl
</#ibizinclude>